#include "24cxx.h" 
#include "delay.h"
//Mini STM32
//24CXX(ʺ24C01~24C16,24C32~256δ!д֤!)
//ԭ@ALIENTEK
//2010/6/10
//V1.2

//ʼIICӿ
void AT24CXX_Init(void)
{
	IIC_Init();
}
//AT24CXXַָһ
//ReadAddr:ʼĵַ  
//ֵ  :
u8 AT24CXX_ReadOneByte(u16 ReadAddr)
{				  
	u8 temp=0;		  	    																 
    IIC_Start();  
	if(EE_TYPE>AT24C16)
	{
		IIC_Send_Byte(0XA0);	   //д
		IIC_Wait_Ack();
		IIC_Send_Byte(ReadAddr>>8);//͸ߵַ
		IIC_Wait_Ack();		 
	}else IIC_Send_Byte(0XA0+((ReadAddr/256)<<1));   //ַ0XA0,д 	 

	IIC_Wait_Ack(); 
    IIC_Send_Byte(ReadAddr%256);   //͵͵ַ
	IIC_Wait_Ack();	    
	IIC_Start();  	 	   
	IIC_Send_Byte(0XA1);           //ģʽ			   
	IIC_Wait_Ack();	 
    temp=IIC_Read_Byte(0);		   
    IIC_Stop();//һֹͣ	    
	return temp;
}
//AT24CXXַָдһ
//WriteAddr  :дݵĿĵַ    
//DataToWrite:Ҫд
void AT24CXX_WriteOneByte(u16 WriteAddr,u8 DataToWrite)
{				   	  	    																 
    IIC_Start();  
	if(EE_TYPE>AT24C16)
	{
		IIC_Send_Byte(0XA0);	    //д
		IIC_Wait_Ack();
		IIC_Send_Byte(WriteAddr>>8);//͸ߵַ
 	}else
	{
		IIC_Send_Byte(0XA0+((WriteAddr/256)<<1));   //ַ0XA0,д 
	}	 
	IIC_Wait_Ack();	   
    IIC_Send_Byte(WriteAddr%256);   //͵͵ַ
	IIC_Wait_Ack(); 	 										  		   
	IIC_Send_Byte(DataToWrite);     //ֽ							   
	IIC_Wait_Ack();  		    	   
    IIC_Stop();//һֹͣ 
	delay_ms(10);	 
}
//AT24CXXַָʼд볤ΪLen
//úд16bit32bit.
//WriteAddr  :ʼдĵַ  
//DataToWrite:׵ַ
//Len        :Ҫдݵĳ2,4
void AT24CXX_WriteLenByte(u16 WriteAddr,u32 DataToWrite,u8 Len)
{  	
	u8 t;
	for(t=0;t<Len;t++)
	{
		AT24CXX_WriteOneByte(WriteAddr+t,(DataToWrite>>(8*t))&0xff);
	}												    
}

//AT24CXXַָʼΪLen
//úڶ16bit32bit.
//ReadAddr   :ʼĵַ 
//ֵ     :
//Len        :Ҫݵĳ2,4
u32 AT24CXX_ReadLenByte(u16 ReadAddr,u8 Len)
{  	
	u8 t;
	u32 temp=0;
	for(t=0;t<Len;t++)
	{
		temp<<=8;
		temp+=AT24CXX_ReadOneByte(ReadAddr+Len-t-1); 	 				   
	}
	return temp;												    
}
//AT24CXXǷ
//24XXһַ(255)洢־.
//24Cϵ,ַҪ޸
//1:ʧ
//0:ɹ
u8 AT24CXX_Check(void)
{
	u8 temp;
	temp=AT24CXX_ReadOneByte(255);//ÿοдAT24CXX			   
	if(temp==0X55)return 0;		   
	else//ųһγʼ
	{
		AT24CXX_WriteOneByte(255,0X55);
	    temp=AT24CXX_ReadOneByte(255);	  
		if(temp==0X55)return 0;
	}
	return 1;											  
}

//AT24CXXַָʼָ
//ReadAddr :ʼĵַ 24c02Ϊ0~255
//pBuffer  :׵ַ
//NumToRead:Ҫݵĸ
void AT24CXX_Read(u16 ReadAddr,u8 *pBuffer,u16 NumToRead)
{
	while(NumToRead)
	{
		*pBuffer++=AT24CXX_ReadOneByte(ReadAddr++);	
		NumToRead--;
	}
}  
//AT24CXXַָʼдָ
//WriteAddr :ʼдĵַ 24c02Ϊ0~255
//pBuffer   :׵ַ
//NumToWrite:Ҫдݵĸ
void AT24CXX_Write(u16 WriteAddr,u8 *pBuffer,u16 NumToWrite)
{
	while(NumToWrite--)
	{
		AT24CXX_WriteOneByte(WriteAddr,*pBuffer);
		WriteAddr++;
		pBuffer++;
	}
}
 











