#include "ILI9341.h"
#include "stdlib.h"
//#include "usart.h"	 
#include "delay.h"
#include "font.h"

//LCD9341Ļɫͱɫ	   
u16 POINT_COLOR=0x0000;	//ɫ
u16 BACK_COLOR=0xFFFF;  //ɫ 

//LCD9341Ҫ
//ĬΪ
_lcd_dev lcddev;
	
		   
//дĴ
//regval:Ĵֵ
void LCD9341_WR_REG(u16 regval)
{ 
	LCD9341->LCD9341_REG=regval;//дҪдļĴ	 
}
//дLCD9341
//data:Ҫдֵ
void LCD9341_WR_DATA(u16 data)
{										    	   
	LCD9341->LCD9341_RAM=data;		 
}
//LCD9341
//ֵ:ֵ
u16 LCD9341_RD_DATA(void)
{										    	   
	return LCD9341->LCD9341_RAM;		 
}					   
//дĴ
//LCD9341_Reg:Ĵַ
//LCD9341_RegValue:Ҫд
void LCD9341_WriteReg(u8 LCD9341_Reg, u16 LCD9341_RegValue)
{	
	LCD9341->LCD9341_REG = LCD9341_Reg;		//дҪдļĴ	 
	LCD9341->LCD9341_RAM = LCD9341_RegValue;//д	    		 
}	   
//Ĵ
//LCD9341_Reg:Ĵַ
//ֵ:
u16 LCD9341_ReadReg(u8 LCD9341_Reg)
{										   
	LCD9341_WR_REG(LCD9341_Reg);		//дҪļĴ
	delay_us(5);		  
	return LCD9341_RD_DATA();		//ضֵ
}   
//ʼдGRAM
void LCD9341_WriteRAM_Prepare(void)
{
 	LCD9341->LCD9341_REG=lcddev.wramcmd;	  
}	 
//LCD9341дGRAM
//RGB_Code:ɫֵ
void LCD9341_WriteRAM(u16 RGB_Code)
{							    
	LCD9341->LCD9341_RAM = RGB_Code;//дʮλGRAM
}
//ILI93xxΪGBRʽдʱΪRGBʽ
//ͨúת
//c:GBRʽɫֵ
//ֵRGBʽɫֵ
u16 LCD9341_BGR2RGB(u16 c)
{
	u16  r,g,b,rgb;   
	b=(c>>0)&0x1f;
	g=(c>>5)&0x3f;
	r=(c>>11)&0x1f;	 
	rgb=(b<<11)+(g<<5)+(r<<0);		 
	return(rgb);
} 
//mdk -O1ʱŻʱҪ
//ʱi
void opt_delay(u8 i)
{
	while(i--);
}
//ȡĳɫֵ	 
//x,y:
//ֵ:˵ɫ
u16 LCD9341_ReadPoint(u16 x,u16 y)
{
 	u16 r=0,g=0,b=0;
	if(x>=lcddev.width||y>=lcddev.height)
        return 0;	//˷Χ,ֱӷ		   
	LCD9341_SetCursor(x,y);	    
    LCD9341_WR_REG(0X2E);//9341/6804 ͶGRAMָ
    if(LCD9341-> LCD9341_RAM) r=0;//dummy Read
    //9341Ҫ2ζ
    opt_delay(2);	  
 	r=LCD9341->LCD9341_RAM;//ʵֵR
	opt_delay(2);	  
	b=LCD9341->LCD9341_RAM; 
	g=r&0XFF;//9341,һζȡRGֵ,Rǰ,Gں,ռ8λ
	g<<=8;
    return (((r>>11)<<11)|((g>>10)<<5)|(b>>11));	//ILI9341Ҫʽתһ
}		 
//LCD9341ʾ
void LCD9341_DisplayOn(void)
{					   
    LCD9341_WR_REG(0X29);	//ʾ
}	 
//LCD9341رʾ
void LCD9341_DisplayOff(void)
{	   
    LCD9341_WR_REG(0X28);	//رʾ
}   
//ùλ
//Xpos:
//Ypos:
void LCD9341_SetCursor(u16 Xpos, u16 Ypos)
{	 
	LCD9341_WR_REG(lcddev.setxcmd); 
	LCD9341_WR_DATA(Xpos>>8); 
	LCD9341_WR_DATA(Xpos&0XFF);	 
	LCD9341_WR_REG(lcddev.setycmd); 
	LCD9341_WR_DATA(Ypos>>8); 
	LCD9341_WR_DATA(Ypos&0XFF);
} 		 
//LCD9341Զɨ跽
//ע:ܻܵ˺õӰ(9341/6804),
//,һΪL2R_U2D,Ϊɨ跽ʽ,ܵʾ.
//dir:0~7,8(嶨lcd.h)
   	   
void LCD9341_Scan_Dir(u8 dir)
{
	u16 regval=0;
	u8 dirreg=0;
	u16 temp;  
	switch(dir)
	{
		case L2R_U2D://,ϵ
			regval|=(0<<7)|(0<<6)|(0<<5); 
			break;
		case L2R_D2U://,µ
			regval|=(1<<7)|(0<<6)|(0<<5); 
			break;
		case R2L_U2D://ҵ,ϵ
			regval|=(0<<7)|(1<<6)|(0<<5); 
			break;
		case R2L_D2U://ҵ,µ
			regval|=(1<<7)|(1<<6)|(0<<5); 
			break;	 
		case U2D_L2R://ϵ,
			regval|=(0<<7)|(0<<6)|(1<<5); 
			break;
		case U2D_R2L://ϵ,ҵ
			regval|=(0<<7)|(1<<6)|(1<<5); 
			break;
		case D2U_L2R://µ,
			regval|=(1<<7)|(0<<6)|(1<<5); 
			break;
		case D2U_R2L://µ,ҵ
			regval|=(1<<7)|(1<<6)|(1<<5); 
			break;	 
	}
	dirreg=0X36;
 	regval|=0X08;//BGR   
	LCD9341_WriteReg(dirreg,regval);
 	if(regval&0X20)
	{
		if(lcddev.width<lcddev.height)//X,Y
		{
			temp=lcddev.width;
			lcddev.width=lcddev.height;
			lcddev.height=temp;
 		}
	}
    else  
	{
		if(lcddev.width>lcddev.height)//X,Y
		{
			temp=lcddev.width;
			lcddev.width=lcddev.height;
			lcddev.height=temp;
 		}
	}  
	LCD9341_WR_REG(lcddev.setxcmd); 
	LCD9341_WR_DATA(0);LCD9341_WR_DATA(0);
	LCD9341_WR_DATA((lcddev.width-1)>>8);LCD9341_WR_DATA((lcddev.width-1)&0XFF);
	LCD9341_WR_REG(lcddev.setycmd); 
	LCD9341_WR_DATA(0);LCD9341_WR_DATA(0);
	LCD9341_WR_DATA((lcddev.height-1)>>8);LCD9341_WR_DATA((lcddev.height-1)&0XFF);
}   
//
//x,y:
//POINT_COLOR:˵ɫ
void LCD9341_DrawPoint(u16 x,u16 y)
{
	LCD9341_SetCursor(x,y);		//ùλ 
	LCD9341_WriteRAM_Prepare();	//ʼдGRAM
	LCD9341->LCD9341_RAM=POINT_COLOR; 
}
//ٻ
//x,y:
//color:ɫ
void LCD9341_Fast_DrawPoint(u16 x,u16 y,u16 color)
{	   
	LCD9341_WR_REG(lcddev.setxcmd); 
	LCD9341_WR_DATA(x>>8); 
	LCD9341_WR_DATA(x&0XFF);	 
	LCD9341_WR_REG(lcddev.setycmd); 
	LCD9341_WR_DATA(y>>8); 
	LCD9341_WR_DATA(y&0XFF);

	LCD9341->LCD9341_REG=lcddev.wramcmd; 
	LCD9341->LCD9341_RAM=color; 
}	 


//LCD9341ʾ6804ֺ֧ʾ
//dir:0,1,
void LCD9341_Display_Dir(u8 dir)
{
	if(dir==0)//
	{
		lcddev.dir=0;//
		lcddev.width=240;
		lcddev.height=320;

		lcddev.wramcmd=0X2C;
	 	lcddev.setxcmd=0X2A;
		lcddev.setycmd=0X2B;  	 
	}
    else	
	{	  
		lcddev.dir=1;//
		lcddev.width=320;
		lcddev.height=240;

        lcddev.wramcmd=0X2C;
	 	lcddev.setxcmd=0X2A;
		lcddev.setycmd=0X2B;  	 
	} 
	LCD9341_Scan_Dir(6);
//	LCD9341_Scan_Dir(DFT_SCAN_DIR);	//Ĭɨ跽
}	 
//ʼlcd
//óʼԳʼILI93XXҺ,ǻILI9320!!!
//ͺŵоƬûв! 
void LCD9341_Init(void)
{ 										  
	GPIO_InitTypeDef GPIO_InitStructure;
	FSMC_NORSRAMInitTypeDef  FSMC_NORSRAMInitStructure;
    FSMC_NORSRAMTimingInitTypeDef  readWriteTiming; 
	FSMC_NORSRAMTimingInitTypeDef  writeTiming;

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC,ENABLE);	//ʹFSMCʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE|RCC_APB2Periph_GPIOG|RCC_APB2Periph_AFIO,ENABLE);//ʹPORTB,D,E,GԼAFIOùʱ

 	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;				 //PB0  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOB, &GPIO_InitStructure);

 	//PORTD  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_14|GPIO_Pin_15;				 //	//PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOD, &GPIO_InitStructure); 
	  
	//PORTE  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;				 //	//PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOE, &GPIO_InitStructure); 
	  
   	//	//PORTG12 A0	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_12;	 //	//PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOG, &GPIO_InitStructure); 
 
	readWriteTiming.FSMC_AddressSetupTime = 0x01;	 //ַʱ䣨ADDSETΪ2HCLK 1/36M=27ns
    readWriteTiming.FSMC_AddressHoldTime = 0x00;	 //ַʱ䣨ADDHLDģʽAδõ	
    readWriteTiming.FSMC_DataSetupTime = 0x0f;		 // ݱʱΪ16HCLK,ΪҺICĶݵʱٶȲ̫죬1289IC
    readWriteTiming.FSMC_BusTurnAroundDuration = 0x00;
    readWriteTiming.FSMC_CLKDivision = 0x00;
    readWriteTiming.FSMC_DataLatency = 0x00;
    readWriteTiming.FSMC_AccessMode = FSMC_AccessMode_A;	 //ģʽA 
    

	writeTiming.FSMC_AddressSetupTime = 0x00;	 //ַʱ䣨ADDSETΪ1HCLK  
    writeTiming.FSMC_AddressHoldTime = 0x00;	 //ַʱ䣨A		
    writeTiming.FSMC_DataSetupTime = 0x03;		 ////ݱʱΪ4HCLK	
    writeTiming.FSMC_BusTurnAroundDuration = 0x00;
    writeTiming.FSMC_CLKDivision = 0x00;
    writeTiming.FSMC_DataLatency = 0x00;
    writeTiming.FSMC_AccessMode = FSMC_AccessMode_A;	 //ģʽA 

 
    FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM4;//  ʹNE4 ҲͶӦBTCR[6],[7]
    FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable; // ݵַ
    FSMC_NORSRAMInitStructure.FSMC_MemoryType =FSMC_MemoryType_SRAM;// FSMC_MemoryType_SRAM;  //SRAM   
    FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;//洢ݿΪ16bit   
    FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode =FSMC_BurstAccessMode_Disable;// FSMC_BurstAccessMode_Disable; 
    FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
	FSMC_NORSRAMInitStructure.FSMC_AsynchronousWait=FSMC_AsynchronousWait_Disable; 
    FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;   
    FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_BeforeWaitState;  
    FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;	//  洢дʹ
    FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Disable;   
    FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Enable; // дʹòͬʱ
    FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable; 
    FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &readWriteTiming; //дʱ
    FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &writeTiming;  //дʱ

    FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure);  //ʼFSMC

   	FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM4, ENABLE);  // ʹBANK1 
			 
// 	delay_ms(50); // delay 50 ms 
 	//9341 IDĶȡ		
	LCD9341_WR_REG(0XD3);				   
	LCD9341_RD_DATA(); 				//dummy read 	
	LCD9341_RD_DATA();   	    	//0X00
	lcddev.id=LCD9341_RD_DATA();   	//ȡ93								   
	lcddev.id<<=8;
	lcddev.id|=LCD9341_RD_DATA();  	//ȡ41 	   			   
//	printf(" LCD9341 ID:%x\r\n",lcddev.id); //ӡLCD9341 ID  
//  9341ʼ
	LCD9341_WR_REG(0xCF);//Power control B
	LCD9341_WR_DATA(0x00); 
	LCD9341_WR_DATA(0xC1);
	LCD9341_WR_DATA(0X30); 
    
	LCD9341_WR_REG(0xED);  //Power on sequence control
	LCD9341_WR_DATA(0x64); 
	LCD9341_WR_DATA(0x03); 
	LCD9341_WR_DATA(0X12); 
	LCD9341_WR_DATA(0X81); 
    
	LCD9341_WR_REG(0xE8);  //Driver timing control A
	LCD9341_WR_DATA(0x85); 
	LCD9341_WR_DATA(0x10); 
	LCD9341_WR_DATA(0x7A);
    
	LCD9341_WR_REG(0xCB);  //Power control B
	LCD9341_WR_DATA(0x39); 
	LCD9341_WR_DATA(0x2C); 
	LCD9341_WR_DATA(0x00); 
	LCD9341_WR_DATA(0x34); 
	LCD9341_WR_DATA(0x02);
    
	LCD9341_WR_REG(0xF7);  //Pump ratio control
	LCD9341_WR_DATA(0x20); 
    
	LCD9341_WR_REG(0xEA); //Driver timing control B 
	LCD9341_WR_DATA(0x00); 
	LCD9341_WR_DATA(0x00); 
    
	LCD9341_WR_REG(0xC0);    //Power control 
	LCD9341_WR_DATA(0x1B);   //VRH[5:0] 
    
	LCD9341_WR_REG(0xC1);    //Power control 
	LCD9341_WR_DATA(0x01);   //SAP[2:0];BT[3:0] 
    
	LCD9341_WR_REG(0xC5);    //VCM control 
	LCD9341_WR_DATA(0x30); 	 //3F
	LCD9341_WR_DATA(0x30); 	 //3C
    
	LCD9341_WR_REG(0xC7);    //VCM control2 
	LCD9341_WR_DATA(0XB7); 
    
	LCD9341_WR_REG(0x36);    // Memory Access Control 
	LCD9341_WR_DATA(0x48); 
    
	LCD9341_WR_REG(0x3A);   //COLMOD: Pixel Format Set
	LCD9341_WR_DATA(0x55); 
    
	LCD9341_WR_REG(0xB1);   //Frame Rate Control (In Normal Mode/Full Colors) 
	LCD9341_WR_DATA(0x00);   
	LCD9341_WR_DATA(0x1A); 
    
	LCD9341_WR_REG(0xB6);    // Display Function Control 
	LCD9341_WR_DATA(0x0A); 
	LCD9341_WR_DATA(0xA2); 
    
	LCD9341_WR_REG(0xF2);    // 3Gamma Function Disable 
	LCD9341_WR_DATA(0x00);
    
	LCD9341_WR_REG(0x26);    //Gamma curve selected 
	LCD9341_WR_DATA(0x01);
    
	LCD9341_WR_REG(0xE0);    //Set Gamma 
	LCD9341_WR_DATA(0x0F); 
	LCD9341_WR_DATA(0x2A); 
	LCD9341_WR_DATA(0x28); 
	LCD9341_WR_DATA(0x08); 
	LCD9341_WR_DATA(0x0E); 
	LCD9341_WR_DATA(0x08); 
	LCD9341_WR_DATA(0x54); 
	LCD9341_WR_DATA(0XA9); 
	LCD9341_WR_DATA(0x43); 
	LCD9341_WR_DATA(0x0A); 
	LCD9341_WR_DATA(0x0F); 
	LCD9341_WR_DATA(0x00); 
	LCD9341_WR_DATA(0x00); 
	LCD9341_WR_DATA(0x00); 
	LCD9341_WR_DATA(0x00); 	
    
	LCD9341_WR_REG(0XE1);    //Set Gamma 
	LCD9341_WR_DATA(0x00); 
	LCD9341_WR_DATA(0x15); 
	LCD9341_WR_DATA(0x17); 
	LCD9341_WR_DATA(0x07); 
	LCD9341_WR_DATA(0x11); 
	LCD9341_WR_DATA(0x06); 
	LCD9341_WR_DATA(0x2B); 
	LCD9341_WR_DATA(0x56); 
	LCD9341_WR_DATA(0x3C); 
	LCD9341_WR_DATA(0x05); 
	LCD9341_WR_DATA(0x10); 
	LCD9341_WR_DATA(0x0F); 
	LCD9341_WR_DATA(0x3F); 
	LCD9341_WR_DATA(0x3F); 
	LCD9341_WR_DATA(0x0F); 
    
	LCD9341_WR_REG(0x2B); //Page Address Set
	LCD9341_WR_DATA(0x00);
	LCD9341_WR_DATA(0x00);
	LCD9341_WR_DATA(0x01);
	LCD9341_WR_DATA(0x3f);
    
	LCD9341_WR_REG(0x2A); //Column Address Set
	LCD9341_WR_DATA(0x00);
	LCD9341_WR_DATA(0x00);
	LCD9341_WR_DATA(0x00);
	LCD9341_WR_DATA(0xef);	
    
	LCD9341_WR_REG(0x11); //Exit Sleep
	delay_ms(120);
	LCD9341_WR_REG(0x29); //display on	
    
	LCD9341_Display_Dir(1);		 	//ĬΪ 0 1
	LCD9341_LED = 1;					//
	LCD9341_Clear(WHITE);
}  
//
//color:Ҫɫ
void LCD9341_Clear(u16 color)
{
	u32 index=0;      
	u32 totalpoint=lcddev.width;
	totalpoint*=lcddev.height; 	//õܵ
	LCD9341_SetCursor(0x00,0x0000);	//ùλ 
	LCD9341_WriteRAM_Prepare();     //ʼдGRAM	 	  
	for(index=0;index<totalpoint;index++)
	{
		LCD9341->LCD9341_RAM=color;	
	}
}  
//ָ䵥ɫ
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)   
//color:Ҫɫ
void LCD9341_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 color)
{          
	u16 i,j;
	u16 xlen=0;
	xlen=ex-sx+1;	   
	for(i=sy;i<=ey;i++)
	{
	 	LCD9341_SetCursor(sx,i);      				//ùλ 
		LCD9341_WriteRAM_Prepare();     			//ʼдGRAM	  
		for(j=0;j<xlen;j++)LCD9341_WR_DATA(color);	//ùλ 	    
	}
}  
//ָָɫ			 
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)   
//color:Ҫɫ
void LCD9341_Color_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color)
{  
	u16 height,width;
	u16 i,j;
	width=ex-sx+1; 		//õĿ
	height=ey-sy+1;		//߶
 	for(i=0;i<height;i++)
	{
 		LCD9341_SetCursor(sx,sy+i);   	//ùλ 
		LCD9341_WriteRAM_Prepare();     //ʼдGRAM
		for(j=0;j<width;j++)
            LCD9341->LCD9341_RAM=color[i*height+j];//д 
	}	  
}

//
//x1,y1:
//x2,y2:յ  
void LCD9341_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2)
{
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 
	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		LCD9341_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}

//ָλûһָСԲ
//(x,y):ĵ
//r    :뾶
void LCD9341_Draw_Circle(u16 x0,u16 y0,u8 r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD9341_DrawPoint(x0+a,y0-b);             //5
 		LCD9341_DrawPoint(x0+b,y0-a);             //0           
		LCD9341_DrawPoint(x0+b,y0+a);             //4               
		LCD9341_DrawPoint(x0+a,y0+b);             //6 
		LCD9341_DrawPoint(x0-a,y0+b);             //1       
 		LCD9341_DrawPoint(x0-b,y0+a);             
		LCD9341_DrawPoint(x0-a,y0-b);             //2             
  		LCD9341_DrawPoint(x0-b,y0-a);             //7     	         
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 						    
	}
}

//ָλʾһַ
//x,y:ʼ
//num:Ҫʾַ:" "--->"~"
//size:С 12/16
//mode:ӷʽ(1)Ƿǵӷʽ(0)
void LCD9341_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
{  							  
    u8 temp,t1,t;
	u16 y0=y;
	u16 colortemp=POINT_COLOR;      			     
	//ô		   
	num=num-' ';//õƫƺֵ
	if(!mode) //ǵӷʽ
	{
	    for(t=0;t<size;t++)
	    {   
			if(size==12)
				temp=asc2_1206[num][t];  //1206
			else 
				temp=asc2_1608[num][t];		 //1608 	                          
	        for(t1=0;t1<8;t1++)
			{			    
		        if(temp&0x80)POINT_COLOR=colortemp;
				else POINT_COLOR=BACK_COLOR;
				LCD9341_DrawPoint(x,y);	
				temp<<=1;
				y++;
				if(x>=lcddev.width){POINT_COLOR=colortemp;return;}//
				if((y-y0)==size)
				{
					y=y0;
					x++;
					if(x>=lcddev.width){POINT_COLOR=colortemp;return;}//
					break;
				}
			}  	 
	    }    
	}else//ӷʽ
	{
	    for(t=0;t<size;t++)
	    {   
			if(size==12)temp=asc2_1206[num][t];  //1206
			else temp=asc2_1608[num][t];		 //1608 	                          
	        for(t1=0;t1<8;t1++)
			{			    
		        if(temp&0x80)LCD9341_DrawPoint(x,y); 
				temp<<=1;
				y++;
				if(x>=lcddev.height){POINT_COLOR=colortemp;return;}//
				if((y-y0)==size)
				{
					y=y0;
					x++;
					if(x>=lcddev.width){POINT_COLOR=colortemp;return;}//
					break;
				}
			}  	 
	    }     
	}
	POINT_COLOR=colortemp;	    	   	 	  
}   
//m^n
//ֵ:m^nη.
u32 LCD9341_Pow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}

//ʾ,λΪ0,ʾ
//x,y :	 
//len :ֵλ
//size:С
//color:ɫ 
//num:ֵ(0~4294967295);	 
void LCD9341_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/LCD9341_Pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD9341_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD9341_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
} 
//ʾ,λΪ0,ʾ
//x,y:
//num:ֵ(0~999999999);	 
//len:(Ҫʾλ)
//size:С
//mode:
//[7]:0,;1,0.
//[6:1]:
//[0]:0,ǵʾ;1,ʾ.
void LCD9341_ShowxNum(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode)
{  
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/LCD9341_Pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				if(mode&0X80)
					LCD9341_ShowChar(x+(size/2)*t,y,'0',size,mode&0X01);  
				else 
					LCD9341_ShowChar(x+(size/2)*t,y,' ',size,mode&0X01);  
 				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD9341_ShowChar(x+(size/2)*t,y,temp+'0',size,mode&0X01); 
	}
} 
//ʾַ
//x,y:
//width,height:С  
//size:С
//*p:ַʼַ		  
void LCD9341_ShowString(u16 x,u16 y,u16 width,u16 height,u8 size,u8 *p)
{         
	u8 x0=x;
	width+=x;
	height+=y;
    while((*p<='~')&&(*p>=' '))//жǲǷǷַ!
    {       
        if(x>=width){x=x0;y+=size;}
        if(y>=height)break;//˳
        LCD9341_ShowChar(x,y,*p,size,0);
        x+=size/2;
        p++;
    }  
}


